'TextAiToIndd v1.3
'       Ai  Indd
'    :
', , , caps, ,    
' 1.0  , 1.1. 
'1.2  , ..,  (     )
'   (  ,  geometricbounds  .)
'1.3       ai   ,     appearance
' ,  ,   ...

main
Sub main()
    Dim appAi, appIndd, inddDoc
    Dim myMsg, selectedItems, pageObject, groupObj
    Dim startIndex, endIndex, index
    Dim ab 'artboardrect
    
    Set appAi = CreateObject("Illustrator.Application")
    Set appIndd = CreateObject("InDesign.Application")
    
    If (appIndd.Documents.Count < 1) Then
        appAi.DoJavaScript "alert('    Indesign!')"
        Exit Sub
    End If
    
    Set inddDoc = appIndd.ActiveDocument
    
    ' indd  ,     (idMeasurementUnits.idMillimeters  )
    If inddDoc.ViewPreferences.HorizontalMeasurementUnits <> 2053991795 Or inddDoc.ViewPreferences.VerticalMeasurementUnits <> 2053991795 Then
        inddDoc.ViewPreferences.HorizontalMeasurementUnits = 2053991795
        inddDoc.ViewPreferences.VerticalMeasurementUnits = 2053991795
    End If
    
    If (appAi.Documents.Count < 1) Then
        appAi.DoJavaScript "alert('Open document and select some text items.')"
        Exit Sub
    End If

    If (IsEmpty(appAi.Selection)) Then
        appAi.DoJavaScript "alert('Nothing is selected.')"
        Exit Sub
    End If
    
    Rem If the user has selected characters inside a text art item then the type of
    Rem the selection is string

    If (TypeName(appAi.Selection) = "TextRange") Then
        myMsg = "alert('   ,     ')"
        appAi.DoJavaScript myMsg
        Exit Sub
    End If
     
    index = appAi.ActiveDocument.Artboards.GetActiveArtboardIndex
    ab = appAi.ActiveDocument.Artboards(index + 1).ArtboardRect

    Rem If one or more art items are selected then a variant array of Objects is returned
    selectedItems = appAi.Selection
    If (TypeName(selectedItems) <> "Variant()") Then
        myMsg = "alert(""Unknown selection type = " & TypeName(selectedItems) & ")"
        appAi.DoJavaScript myMsg
        ' MsgBox "Unknown selection type = " & TypeName(selectedItems)
        Exit Sub
    End If
        
    Rem run through the returned array
    Rem (startIndex will always be 0)
    
    index = 0
    startIndex = LBound(selectedItems)
    endIndex = UBound(selectedItems)
    
    For index = startIndex To endIndex
        Set pageObject = selectedItems(index)
        If (pageObject.PageItemType = 10) Then  ' chk if aiTextFrame
            If Trim(pageObject.Contents) <> "" Then TextFrameFormAi ab, pageObject, appIndd, inddDoc
        ElseIf (pageObject.PageItemType = 3) Then
            For Each groupObj In pageObject.PageItems
                If (groupObj.PageItemType = 10) Then  ' chk if aiTextFrame
                    If Trim(groupObj.Contents) <> "" Then TextFrameFormAi ab, groupObj, appIndd, inddDoc
                End If
            Next
        End If
    Next
End Sub

Private Sub TextFrameFormAi(abr, aisel, myIndd, myInddDoc)
    Dim gb 'geometricbounds
    Dim gb_temp(3)
    Dim arrayColorName()
    ReDim arrayColorName(0)
    Dim myTextFrame, tempColorName, myFontName
    Dim chk, n, i, j, k
    Dim cC, cM, cY, cK
    Dim rR, rG, rB
    Dim charcount, parcount, cEnd, linebrk 'frame char count, frame paragraph count, paragraph end char, line break check

    tempColorName = ""
    arrayColorName(0) = ""
    chk = False
    n = 0
    k = 0
    linebrk = False

    '     swatches
    n = 0 '  ,      -
    For i = 1 To myInddDoc.Colors.Count
        If n > 0 Then ReDim Preserve arrayColorName(n)
        arrayColorName(n) = myInddDoc.Colors(i).name
        n = n + 1
    Next
    
    gb = aisel.geometricbounds
    
    '    point -> mm
    'Ai-geometricbounds: X, -Y, X + Width, -(Y + Height)
    '     
    
    gb(0) = (gb(0) - abr(0)) / 72 * 25.4
    gb(1) = (gb(1) - abr(1)) / 72 * 25.4 * -1
    gb(2) = (gb(2) - abr(0)) / 72 * 25.4
    gb(3) = (gb(3) - abr(1)) / 72 * 25.4 * -1
    
    '      indd
    '   indd X -> X
    'Indd-geometricbounds: Y, X, Y + Height, X + Width
    n = gb(0)
    gb(0) = gb(1)
    gb(1) = n
    n = gb(2)
    gb(2) = gb(3)
    gb(3) = n
    
    '      indd (  )
    gb_temp(0) = 0
    gb_temp(1) = 0
    gb_temp(2) = (abr(3) - abr(1)) / 72 * 25.4 * -1
    gb_temp(3) = (abr(2) - abr(0)) / 72 * 25.4

    Set myTextFrame = myIndd.ActiveWindow.ActivePage.TextFrames.Add
    myTextFrame.geometricbounds = gb_temp
    myTextFrame.Contents = aisel.Contents
    CheckLineBreak myTextFrame, aisel.Contents
        
    myTextFrame.TextStyleRanges(1).Hyphenation = False
    
    charcount = aisel.Characters.Count
    If Asc(aisel.Characters(charcount).Contents) = 13 Then
        parcount = aisel.Paragraphs.Count - 1 '   ai      
    Else
        parcount = aisel.Paragraphs.Count
    End If
    k = 1
    For i = 1 To parcount
        If aisel.Paragraphs(i).Characters.Count = 0 Then
            '   ,       
            n = aisel.Paragraphs(i).CharacterOffset
            myTextFrame.Paragraphs(k).PointSize = aisel.Characters(n).CharacterAttributes.Size
            myTextFrame.Paragraphs(k).Leading = aisel.Characters(n).CharacterAttributes.Leading
            myTextFrame.Paragraphs(k).spaceBefore = ptTomm(aisel.Characters(n).ParagraphAttributes.spaceBefore)
            myTextFrame.Paragraphs(k).spaceAfter = ptTomm(aisel.Characters(n).ParagraphAttributes.spaceAfter)
        Else
            If linebrk = False Then
                If aisel.Paragraphs(i).Characters(1).CharacterAttributes.capitalization = 2 Then _
                    myTextFrame.Paragraphs(k).capitalization = 1634493296
                myTextFrame.Paragraphs(k).PointSize = aisel.Paragraphs(i).Characters(1).CharacterAttributes.Size
                myFontName = aisel.Paragraphs(i).Characters(1).CharacterAttributes.TextFont.Family _
                            & vbTab & aisel.Paragraphs(i).Characters(1).CharacterAttributes.TextFont.Style
                myTextFrame.Paragraphs(k).Leading = aisel.Paragraphs(i).Characters(1).CharacterAttributes.Leading
                myTextFrame.Paragraphs(k).spaceBefore = ptTomm(aisel.Paragraphs(i).ParagraphAttributes.spaceBefore)
                myTextFrame.Paragraphs(k).spaceAfter = ptTomm(aisel.Paragraphs(i).ParagraphAttributes.spaceAfter)
                myTextFrame.Paragraphs(k).AppliedFont = myIndd.Fonts.Item(myFontName)
            
                '- Color ----------------------------------------
                If aisel.Paragraphs(i).Characters(1).CharacterAttributes.FillColor.TypeName = "CMYKColor" Then
					'msgbox "CMYK"
                    cC = Round(aisel.Paragraphs(i).Characters(1).CharacterAttributes.FillColor.Cyan)
                    cM = Round(aisel.Paragraphs(i).Characters(1).CharacterAttributes.FillColor.Magenta)
                    cY = Round(aisel.Paragraphs(i).Characters(1).CharacterAttributes.FillColor.Yellow)
                    cK = Round(aisel.Paragraphs(i).Characters(1).CharacterAttributes.FillColor.Black)
                    tempColorName = "C=" & cC & " M=" & cM & " Y=" & cY & " K=" & cK
                ElseIf aisel.Paragraphs(i).Characters(1).CharacterAttributes.FillColor.TypeName = "RGBColor" Then
					'msgbox "RGB"
                    rR = aisel.Paragraphs(i).Characters(1).CharacterAttributes.FillColor.Red
                    rG = aisel.Paragraphs(i).Characters(1).CharacterAttributes.FillColor.Green
                    rB = aisel.Paragraphs(i).Characters(1).CharacterAttributes.FillColor.Blue
                    tempColorName = "R=" & rR & " G=" & rG & " B=" & rB
				Else
                    cC = 0
                    cM = 0
                    cY = 0
                    cK = 100
                    tempColorName = "C=0 M=0 Y=0 K=100"					
                End If
              
                '        
                n = UBound(arrayColorName)
                For j = 0 To n
                    If arrayColorName(j) = tempColorName Then
                        chk = True
                        Exit For
                    End If
                Next
                
                If chk = False Then
                    ReDim Preserve arrayColorName(n + 1)
                    arrayColorName(n + 1) = tempColorName
                    
                    If Left(tempColorName, 1) = "C" Then
                        myAddColor myInddDoc, tempColorName, 1129142603, Array(cC, cM, cY, cK)
                    Else
                        myAddColor myInddDoc, tempColorName, 1666336578, Array(rR, rG, rB)
                    End If
                End If
                chk = False
                myTextFrame.Paragraphs(k).FillColor = myInddDoc.Colors.Item(tempColorName)
                '---------------------------------------------
                
                'vba   : idJustification.idLeftAlign,   1818584692
                '    msgbox myIndd.Selection(1).TextStyleRanges(1).Justification
                Select Case aisel.Paragraphs(i).Paragraphs(1).ParagraphAttributes.Justification
                    Case 2 'aiCenter
                        myTextFrame.Paragraphs(k).Justification = 1667591796
                    Case 0 'left
                        myTextFrame.Paragraphs(k).Justification = 1818584692
                    Case 1 'right
                        myTextFrame.Paragraphs(k).Justification = 1919379572
                    Case 3 'just left
                        myTextFrame.Paragraphs(k).Justification = 1818915700
                    Case Else 'center
                        myTextFrame.Paragraphs(k).Justification = 1667591796
                End Select
            End If
        End If
        
        cEnd = aisel.Paragraphs(i).End
        If cEnd + 1 <= charcount Then
            If Asc(aisel.Characters(cEnd + 1).Contents) = 3 Then
                linebrk = True
            Else
                linebrk = False
                k = k + 1
            End If
        End If
    Next 'Paragraph
    
    CheckGeometricBounds gb '    (    )
    myTextFrame.geometricbounds = gb
    If myTextFrame.overflows = True Then IncreaseFrameSize gb_temp, myTextFrame
End Sub

Private Sub CheckLineBreak(frmtxt, txt)
    Dim i
    For i = 1 To Len(txt)
        If Asc(Mid(txt, i, 1)) = 3 Then
            frmtxt.Characters(i).Contents = 1397124194 'FORCED_LINE_BREAK
        End If
    Next
End Sub

Private Sub CheckGeometricBounds(cgb)
    If cgb(2) < cgb(0) + 0.5 And cgb(2) > cgb(0) - 0.5 Then
        cgb(2) = cgb(2) + 2
    End If
    If cgb(3) < cgb(1) + 0.5 And cgb(3) > cgb(1) - 0.5 Then
        cgb(3) = cgb(3) + 2
    End If
End Sub

Private Function ptTomm(pt)
    ptTomm = pt / 72 * 25.4
End Function

Private Sub IncreaseFrameSize(spage, sTextFrame)
    Dim gb
    Dim exiteloop
    
    exiteloop = False
    gb = sTextFrame.geometricbounds
    Do While exiteloop = False
        gb(0) = gb(0) - 0.5
        gb(2) = gb(2) + 0.5
        gb(1) = gb(1) - 0.5
        gb(3) = gb(3) + 0.5
        sTextFrame.geometricbounds = gb
        If sTextFrame.overflows = False Then exiteloop = True
        If spage(3) < gb(3) - gb(1) Then exiteloop = True
        If spage(2) < gb(2) - gb(0) Then exiteloop = True
    Loop
End Sub

Private Sub myAddColor(myDocument, myColorName, myColorSpace, myColorValue)
    Dim myColor
    On Error Resume Next
    'If the color does not already exist, InDesign will generate an error.
    Set myColor = myDocument.Colors.Item(myColorName)
    If Err.Number <> 0 Then
        Set myColor = myDocument.Colors.Add
        myColor.name = myColorName
        Err.Clear
    End If
    On Error GoTo 0
    myColor.model = 1886548851 'idColorModel.idProcess
    myColor.Space = myColorSpace
    myColor.colorValue = myColorValue
End Sub